import java.util.*;
import java.io.*;

public class Main {
    public static void main(String... args) {
	PipedWriter ecrivain = new PipedWriter();
	PipedReader lecteur = null;
	try {
	    lecteur = new PipedReader(ecrivain);
	}
	catch(IOException ioe) {
	    System.err.println("erreur création lecteur");
	}
	Detecteur d = new Detecteur(lecteur);
	d.start();
	Scanner s = new Scanner(System.in);
	while (true) {
	    s.nextLine();
	    try {
		ecrivain.write('A');
		ecrivain.flush();
		System.out.println("écriture faite");
	    }
	    catch(IOException ioe) {
		System.err.println("erreur write");
	    }
	}
    }
}

/*class Flux extends InputStream {
    private ArrayDeque<String> octets = new ArrayDeque<>();
    private Boolean interrompu = false;
    @Override
    public int read() {
	if (octets.size() == 0) {
	    System.out.println("buffer vide");
	    interrompu = true;
	}
	while (interrompu) {
	    try {
		Thread.sleep(10);
	    }
	    catch(InterruptedException ie) {}
	}
	System.out.println("buffer de taille " + octets.size());
	byte b = octets.pollFirst();
	return b;
    }

    public void write(byte b) {
	System.out.print("dans write");
	octets.addLast(b);
	interrompu = false;
    }
}
*/
class Detecteur extends Thread {
    private Reader entree;
    public Detecteur(Reader monEntree) {
	entree = monEntree;
    }
    @Override
    public void run() {
	int i = 0;
	while (i < 100) {
	    System.out.println("ecouteur " + i);
	    if (i > 0 && i % 5 == 0) {
		int x = 0;
		try {
		    x = entree.read();
		}
		catch(IOException ioe) {
		    System.err.println("erreur read");
		}
	    }
	    i++;
	    try {
		Thread.sleep(500);
	    }
	    catch(InterruptedException ie) {}
	}
    }
}
